#include <iostream>

class Test
{
public:
	void fonc1() {std::cout << "fonc1" << std::endl;}
	void fonc2() {std::cout << "fonc2" << std::endl;}
};



int main()
{
	Test a;
	void (Test::*p)();

	p = &Test::fonc1;
	(a.*p)();

	p = &Test::fonc2;
	(a.*p)();

	return 0;
}

/*!F
	Ah les pointeurs de mthode et leur syntaxe exotique...

	Dans la classe Test, je fais deux fontions ayant la mme signature : fonc1 et fonc2
	Dedans, juste un cout qui dit par ou on passe...

	Dans le main, je dclare un pointeur p sur une mthode de Test, qui retourne void et ne prend pas d'arguments.
	void (Test::*p)();

	Puis je pose mon pointeur sur la mthode fonc1.
	Notez que jusque la, je n'ai pas considr du tout l'instance : le pointeur est pos sur la classe, et non une instance.

	C'ets quand je dcide d'appeler le pointeur, donc lancer la mthode, que cette fois ci je lui parle d'une instance a.
	La syntaxe est la suivante :

	(a.*p)();

	Si je voulais mettre des paramtres, je les mettrais dans les parenthses qui suivent, 
	si je voulais rcuprer une valeur de retour, je ferais plouf = (a.*p)();

	A la fin du programme, je change le pointeur de place, et je relance depuis l'instance a.

	Cet exemple permet juste de montrer la syntaxe exotique de la chose.
	Personnellement, il m'vitera de chercher  chaque fois sur le net.
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Pointeurs sur mthode
titreE: Pointers on methods.
meta: C++;pointeurs sur mthodes
metaE: C++;pointes methods
desc : Pointeurs sur mthode
descE : Pointers on methods.
cle  : 
*/

